/// <reference types="node" />
type Neverize<T> = {
    [key in keyof T]?: never;
};
type OneOf<A, B> = (A & Neverize<B>) | (B & Neverize<A>);
export interface PeriodicTaskParams {
    cron: string;
}
export interface OneOffTaskParams {
    runsAt: Date;
    _executed?: boolean;
}
export type Task = OneOf<PeriodicTaskParams, OneOffTaskParams> & {
    name: string;
    path?: string;
    execute(): Promise<void>;
};
export interface GlobOptions {
    folder: string;
    pattern: string;
    transpiledFolder: string;
}
export interface ArrayOptions {
    tasks: Task[];
}
interface EventListeners {
    onTaskComplete?: (task: Task) => void | Promise<void>;
}
export type CronRunnerOptions<A extends GlobOptions | ArrayOptions> = {
    tickTime?: number;
} & EventListeners & (A extends GlobOptions ? GlobOptions & Neverize<ArrayOptions> : ArrayOptions & Neverize<GlobOptions>);
export declare function createTaskRunner<A extends GlobOptions | ArrayOptions>(options: CronRunnerOptions<A>): Promise<{
    tid: NodeJS.Timer;
    stop: () => void;
    appendTasks: (tasks: Task[]) => void;
}>;
export {};
//# sourceMappingURL=index.d.ts.map